/*
 * Created on Oct 6, 2006
 *
 */
package jPDFViewerSamples.bookmark;


import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JDialog;

public class AddBookmarkController implements ActionListener
{
    // Reference to the dialog
    private AddBookmarkDialog m_Dialog;
    
    // Returned bookmark
    private BookmarkInfo m_Bookmark;
    
    // Action commands
    private final static String CMD_OK = "Ok";
    private final static String CMD_CANCEL = "Cancel";
    
    public BookmarkInfo showDialog (Frame parentFrame, BookmarkInfo bookmark)
    {
        // Create the dialog
        m_Dialog = new AddBookmarkDialog ();
        centerDialog (parentFrame, m_Dialog);
        
        // Show the bookmark information
        m_Bookmark = bookmark;
        m_Dialog.getJtfName().setText(m_Bookmark.getName());
        m_Dialog.getjlPage().setText (Integer.toString(m_Bookmark.getPageNumber()));
        m_Dialog.getjlSource().setText (m_Bookmark.getSource());
        m_Dialog.getJtfName().selectAll();
        
        // Listeners
        m_Dialog.getJbOk().setActionCommand(CMD_OK);
        m_Dialog.getJbOk().addActionListener(this);
        m_Dialog.getJbCancel().setActionCommand(CMD_CANCEL);
        m_Dialog.getJbCancel().addActionListener(this);
        
        // Show the dialog
        m_Dialog.setVisible(true);
        
        return m_Bookmark;
    }
    
    public void actionPerformed(ActionEvent e)
    {
        if (e.getActionCommand() == CMD_OK)
        {
            m_Bookmark.setName(m_Dialog.getJtfName().getText());
            m_Dialog.dispose();
        }
        else if (e.getActionCommand() == CMD_CANCEL)
        {
            m_Bookmark = null;
            m_Dialog.dispose();
        }
    }
    
    public void centerDialog (Frame parentFrame, JDialog dialog)
    {
        // bit of a hack, IE frames report their location as 0, 0 regardless of where they are on the window
        if (parentFrame.getClass().getName() != null && parentFrame.getClass().getName().toLowerCase().indexOf("iexplorer") != -1)
        {
            int centerX = (parentFrame.getWidth() - dialog.getWidth()) / 2;
            int centerY = (parentFrame.getHeight() - dialog.getHeight()) / 2;
            dialog.setLocation (parentFrame.getLocationOnScreen().x + centerX, parentFrame.getLocationOnScreen().y + centerY);
        }
        else
        {
            int centerX = (parentFrame.getWidth() - dialog.getWidth()) / 2;
            int centerY = (parentFrame.getHeight() - dialog.getHeight()) / 2;
            dialog.setLocation (parentFrame.getX() + centerX, parentFrame.getY() + centerY);
        }
    }

}
