/*
 * Created on Mar 3, 2008
 *
 */
package jPDFViewerSamples.bookmark;

import jPDFViewerSamples.SampleUtil;

import java.awt.Font;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;

import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JSeparator;
import javax.swing.UIManager;

import com.qoppa.pdf.PrintSettings;
import com.qoppa.pdfViewer.PDFViewerBean;
import com.qoppa.pdfViewer.panels.PDFPanel;

public class ViewerFrame extends JFrame
{
    private JPanel jPanel = null;
    private JMenuBar jMenuBar1 = null;
    private JMenu jmFile = null;
    private JMenu jmToolbar = null;
    private JMenuItem jmiPrint = null;
    private JSeparator jSeparator = null;
    private JMenuItem jmiExit = null;
    private JCheckBoxMenuItem jcbShowToolbar = null;
    private JSeparator jSeparator1 = null;
    private JCheckBoxMenuItem jcbShowOpen = null;
    private JCheckBoxMenuItem jcbShowPrint = null;
    private JCheckBoxMenuItem jcbShowSelectToolbar = null;
    private PDFViewerBeanBookmarks viewerBean;
    
    /**
     * This method initializes 
     * 
     */
    public ViewerFrame()
    {
        super();
        initialize();
    }

    /**
     * This method initializes jCheckBoxMenuItem    
     *  
     * @return javax.swing.JCheckBoxMenuItem    
     */
    private JCheckBoxMenuItem getJcbShowSelectToolbar()
    {
        if (jcbShowSelectToolbar == null)
        {
            jcbShowSelectToolbar = new JCheckBoxMenuItem();
            jcbShowSelectToolbar.setFont(new Font("Dialog", Font.PLAIN, (int)SampleUtil.getScaledFont(jcbShowSelectToolbar.getFont().getSize(), 12)));
            jcbShowSelectToolbar.setText("Show Select Toolbar");
            jcbShowSelectToolbar.setSelected(true);
            jcbShowSelectToolbar.addChangeListener(new javax.swing.event.ChangeListener() { 
                public void stateChanged(javax.swing.event.ChangeEvent e)
                {
                    getPDFViewer().getSelectToolbar().setVisible(jcbShowSelectToolbar.isSelected());
                }
            });
        }
        return jcbShowSelectToolbar;
    }

    public static void  main (String [] args)
    {
        setLookAndFeel();
        ViewerFrame frame = new ViewerFrame ();
        frame.setVisible(true);
    }
    
    /**
     * This method initializes this
     * 
     * @return void
     */
    private void initialize() 
    {
        this.setJMenuBar(getJMenuBar1());
        this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        this.setContentPane(getJPanel());
        this.setSize((int)(800 * SampleUtil.getDPIScalingMultiplier()), (int)(600 * SampleUtil.getDPIScalingMultiplier()));
        this.setLocationRelativeTo(null);
         
        this.addWindowListener(new java.awt.event.WindowAdapter() { 
            public void windowOpened(java.awt.event.WindowEvent e) 
            {    
                // Title bar
                setTitle("jPDFViewer Sample - " + PDFViewerBean.getVersion());
            }
        });
        
        addComponentListener(new ComponentAdapter ()
                {
                    public void componentResized (ComponentEvent e)
                    {
                        getPDFViewer().setSize (getJPanel().getWidth() - 20, getJPanel().getHeight() - getPDFViewer().getY() - 10);
                        getPDFViewer().revalidate();
                    }
                    
                    public void componentShown (ComponentEvent e)
                    {
                        getPDFViewer().setLocation (10, 10);
                        getPDFViewer().setSize (getJPanel().getWidth() - 20, getJPanel().getHeight() - getPDFViewer().getY() - 10);
                        getPDFViewer().revalidate();
                    }
                });
    }
    
    /**
     * This method initializes jPanel   
     *  
     * @return javax.swing.JPanel   
     */    
    private JPanel getJPanel() {
        if (jPanel == null) {
            jPanel = new JPanel();
            jPanel.setLayout(null);
            jPanel.add(getPDFViewer(), null);
        }
        return jPanel;
    }
    /**
     * This method initializes PDFViewer    
     *  
     * @return com.qoppa.pdfViewer.PDFViewer    
     */    
    private PDFViewerBeanBookmarks getPDFViewer() {
        if (viewerBean == null) {
            viewerBean = new PDFViewerBeanBookmarks();
            viewerBean.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
            viewerBean.setBounds((int)(10 * SampleUtil.getDPIScalingMultiplier()), (int)(10 * SampleUtil.getDPIScalingMultiplier()), (int)(780 * SampleUtil.getDPIScalingMultiplier()), (int)(445 * SampleUtil.getDPIScalingMultiplier()));
        
            viewerBean.getBookmarkPanel().setActivePolicy(PDFPanel.ALWAYS_ACTIVE);
        }
        return viewerBean;
    }
    
    /**
     * This method initializes jMenuBar1    
     *  
     * @return javax.swing.JMenuBar 
     */    
    private JMenuBar getJMenuBar1() {
        if (jMenuBar1 == null) {
            jMenuBar1 = new JMenuBar();
            jMenuBar1.add(getJmFile());
            jMenuBar1.add(getJmToolbar());
        }
        return jMenuBar1;
    }
    /**
     * This method initializes jMenu    
     *  
     * @return javax.swing.JMenu    
     */    
    private JMenu getJmFile() {
        if (jmFile == null) {
            jmFile = new JMenu();
            jmFile.setText("File");
            jmFile.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, (int)SampleUtil.getScaledFont(jmFile.getFont().getSize(), 12)));
            jmFile.add(getJmiPrint());
            jmFile.add(getJSeparator());
            jmFile.add(getJmiExit());
        }
        return jmFile;
    }
    /**
     * This method initializes jMenu1   
     *  
     * @return javax.swing.JMenu    
     */    
    private JMenu getJmToolbar() {
        if (jmToolbar == null) {
            jmToolbar = new JMenu();
            jmToolbar.setText("Toolbar");
            jmToolbar.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, (int)SampleUtil.getScaledFont(jmToolbar.getFont().getSize(), 12)));
            jmToolbar.add(getJcbShowToolbar());
            jmToolbar.add(getJcbShowSelectToolbar());
            jmToolbar.add(getJSeparator1());
            jmToolbar.add(getJcbShowOpen());
            jmToolbar.add(getJcbShowPrint());
        }
        return jmToolbar;
    }
    /**
     * This method initializes jMenuItem1   
     *  
     * @return javax.swing.JMenuItem    
     */    
    private JMenuItem getJmiPrint() {
        if (jmiPrint == null) {
            jmiPrint = new JMenuItem();
            jmiPrint.setText("Print");
            jmiPrint.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, (int)SampleUtil.getScaledFont(jmiPrint.getFont().getSize(), 12)));
            jmiPrint.addActionListener(new java.awt.event.ActionListener() { 
                public void actionPerformed(java.awt.event.ActionEvent e) 
                {
                    try
                    {
                        getPDFViewer().print((PrintSettings)null);
                    }
                    catch (Exception exc)
                    {
                        JOptionPane.showMessageDialog(getContentPane(), exc.getMessage());
                    }
                }
            });
        }
        return jmiPrint;
    }
    /**
     * This method initializes jSeparator   
     *  
     * @return javax.swing.JSeparator   
     */    
    private JSeparator getJSeparator() {
        if (jSeparator == null) {
            jSeparator = new JPopupMenu.Separator();
        }
        return jSeparator;
    }
    /**
     * This method initializes jMenuItem2   
     *  
     * @return javax.swing.JMenuItem    
     */    
    private JMenuItem getJmiExit() {
        if (jmiExit == null) {
            jmiExit = new JMenuItem();
            jmiExit.setText("Exit");
            jmiExit.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, (int)SampleUtil.getScaledFont(jmiExit.getFont().getSize(), 12)));
            jmiExit.addActionListener(new java.awt.event.ActionListener() { 
                public void actionPerformed(java.awt.event.ActionEvent e)
                {
                    System.exit(0);
                }
            });
        }
        return jmiExit;
    }
    /**
     * This method initializes jCheckBoxMenuItem    
     *  
     * @return javax.swing.JCheckBoxMenuItem    
     */    
    private JCheckBoxMenuItem getJcbShowToolbar() {
        if (jcbShowToolbar == null) {
            jcbShowToolbar = new JCheckBoxMenuItem();
            jcbShowToolbar.setText("Show Toolbar");
            jcbShowToolbar.setSelected(true);
            jcbShowToolbar.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, (int)SampleUtil.getScaledFont(jcbShowToolbar.getFont().getSize(), 12)));
            jcbShowToolbar.addChangeListener(new javax.swing.event.ChangeListener() { 
                public void stateChanged(javax.swing.event.ChangeEvent e)
                {
                    getPDFViewer().getToolbar().setVisible(jcbShowToolbar.isSelected());
                }
            });
        }
        return jcbShowToolbar;
    }
    /**
     * This method initializes jSeparator1  
     *  
     * @return javax.swing.JSeparator   
     */    
    private JSeparator getJSeparator1() {
        if (jSeparator1 == null) {
            jSeparator1 = new JPopupMenu.Separator();
        }
        return jSeparator1;
    }
    /**
     * This method initializes jCheckBoxMenuItem1   
     *  
     * @return javax.swing.JCheckBoxMenuItem    
     */    
    private JCheckBoxMenuItem getJcbShowOpen() {
        if (jcbShowOpen == null) {
            jcbShowOpen = new JCheckBoxMenuItem();
            jcbShowOpen.setText("Show Open Button");
            jcbShowOpen.setSelected(true);
            jcbShowOpen.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, (int)SampleUtil.getScaledFont(jcbShowOpen.getFont().getSize(), 12)));
            jcbShowOpen.addChangeListener(new javax.swing.event.ChangeListener() { 
                public void stateChanged(javax.swing.event.ChangeEvent e)
                {
                    getPDFViewer().getToolbar().getjbOpen().setVisible (jcbShowOpen.isSelected());
                }
            });
        }
        return jcbShowOpen;
    }
    /**
     * This method initializes jCheckBoxMenuItem2   
     *  
     * @return javax.swing.JCheckBoxMenuItem    
     */    
    private JCheckBoxMenuItem getJcbShowPrint() {
        if (jcbShowPrint == null) {
            jcbShowPrint = new JCheckBoxMenuItem();
            jcbShowPrint.setText("Show Print Button");
            jcbShowPrint.setSelected(true);
            jcbShowPrint.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, (int)SampleUtil.getScaledFont(jcbShowPrint.getFont().getSize(), 12)));
            jcbShowPrint.addItemListener(new java.awt.event.ItemListener() { 
                public void itemStateChanged(java.awt.event.ItemEvent e) 
                {
                    getPDFViewer().getToolbar().getjbPrint().setVisible (jcbShowPrint.isSelected());
                }
            });
        }
        return jcbShowPrint;
    }
    
    /**
     * Set the look and feel.  The jPDFViewer library is look and feel independent, so it
     * will inherit any look and feel set by the host application.  In this sample, we are
     * setting the look and feel to the system default look and feel.
     */
    private static void setLookAndFeel ()
    {
        // Set the look and feel
        try
        {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch (Throwable t)
        {
            try
            {
                UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
            }
            catch (Throwable tt)
            {
                // ignore
            }
        }
    }
}
