/*
 * Created on Jul 3, 2009
 *
 */
package jPDFViewerSamples.textSearch;

import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.Point2D;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;

import com.qoppa.pdf.TextSelection;

public class MultiTextSelection implements TextSelection
{
	List<TextSelection> textSelections = new ArrayList<TextSelection>();
	
    public void addSelection (TextSelection ts)
    {
        textSelections.add(ts);
    }
    
    @Deprecated
    public Vector<Point2D[]> getQuadrilaterals()
    {
    	return new Vector<Point2D[]>(getViewQuadrilaterals());
    }
    
    @Deprecated
    public Shape getSelectionShape()
    {
    	return getViewSelectionShape();
    }
    
    public int getSelectionCount()
    {
        return textSelections.size();
    }
    
    public String getText()
    {
    	StringBuilder sb = new StringBuilder();
    	for (TextSelection sel : textSelections)
    	{
    		if (sb.length() > 0)
    		{
    			sb.append("\n");
    		}
    		sb.append(sel.getText());
    	}
        return sb.toString();
    }

	@Override
	public List<Point2D[]> getPDFQuadrilaterals()
	{
		List<Point2D[]> result = new ArrayList<Point2D[]>();
		for (TextSelection sel : textSelections)
		{
			result.addAll(sel.getPDFQuadrilaterals());
		}
		return result;
	}

	@Override
	public List<Point2D[]> getViewQuadrilaterals()
	{
		List<Point2D[]> result = new ArrayList<Point2D[]>();
		for (TextSelection sel : textSelections)
		{
			result.addAll(sel.getViewQuadrilaterals());
		}
		return result;
	}

	@Override
	public Shape getPDFSelectionShape()
	{
		GeneralPath result = new GeneralPath();
    	for (TextSelection sel : textSelections)
    	{
    		result.append(sel.getPDFSelectionShape(), false);
    	}
    	return result;
	}

	@Override
	public Shape getViewSelectionShape()
	{
		GeneralPath result = new GeneralPath();
    	for (TextSelection sel : textSelections)
    	{
    		result.append(sel.getViewSelectionShape(), false);
    	}
    	return result;
	}
	
    public String getText(boolean lineBreaks)
    {
    	StringBuilder sb = new StringBuilder();
    	for (TextSelection sel : textSelections)
    	{
    		if (sb.length() > 0)
    		{
    			sb.append("\n");
    		}
    		sb.append(sel.getText(lineBreaks));
    	}
        return sb.toString();
    }
}
