/*
 * Created on Jul 3, 2009
 *
 */
package jPDFViewerSamples.textSearch;

import jPDFViewerSamples.SampleUtil;

import java.awt.BorderLayout;

import javax.swing.JFrame;
import javax.swing.JPanel;

public class TestFrame extends JFrame
{
    private JPanel jpContentPane = null;
    private MyViewerBean m_ViewerBean = null;

    /**
     * This method initializes 
     * 
     */
    public TestFrame() {
        super();
        initialize();
    }

    /**
     * This method initializes this
     * 
     */
    private void initialize() {
        this.setBounds(0, 0, (int)(800 * SampleUtil.getDPIScalingMultiplier()), (int)(600 * SampleUtil.getDPIScalingMultiplier()));
        this.setTitle("Text Search with Multiple Selection");
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setContentPane(getJpContentPane());
            
    }

    /**
     * This method initializes jpContentPane    
     *  
     * @return javax.swing.JPanel   
     */
    private JPanel getJpContentPane()
    {
        if (jpContentPane == null)
        {
            jpContentPane = new JPanel();
            jpContentPane.setLayout(new BorderLayout());
            jpContentPane.add(getViewerBean(), BorderLayout.CENTER);
        }
        return jpContentPane;
    }

    /**
     * This method initializes CPDFViewerBean   
     *  
     * @return viewerBean.CPDFViewerBean    
     */
    private MyViewerBean getViewerBean()
    {
        if (m_ViewerBean == null)
        {
            m_ViewerBean = new MyViewerBean();
        }
        return m_ViewerBean;
    }

    public static void main (String [] args)
    {
        TestFrame tf = new TestFrame();
        tf.setLocationRelativeTo(null);
        tf.setVisible (true);
    }
}
