/*
 * Created on May 22, 2009
 *
 */
package jPDFViewerSamples.textSearch;

import jPDFViewerSamples.SampleUtil;

import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Insets;
import java.awt.Window;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;

public class TextSearchDialog extends JDialog implements ComponentListener
{
    private JPanel jpContentPane = null;  //  @jve:decl-index=0:visual-constraint="542,31"
    private JButton jbClose = null;
    private JList jlOccurences = null;
    private JScrollPane jScrollPane = null;
    private JButton jbSearch = null;
    private JTextField jtSearchText = null;
    private JLabel jlNumberOccurences = null;
    private JLabel jlProgress = null;
    private JCheckBox jcbCaseSensitive = null;
    private JCheckBox jcbWholeWord = null;
    private JButton  jbNext = null;
    private JButton  jbPrevious = null;
    
    /**
     * This method initializes 
     * 
     */
    public TextSearchDialog(Dialog dialog) 
    {
        super(dialog);
        initialize();
    }

    public TextSearchDialog(Frame parent) 
    {
        super(parent);
        initialize();
    }
    
    public static TextSearchDialog getInstance (Window parent)
    {
        if (parent instanceof Frame)
        {
            return new TextSearchDialog((Frame)parent);
        }
        else if (parent instanceof Dialog)
        {
            return new TextSearchDialog ((Dialog)parent);
        }
        else
        {
            return new TextSearchDialog ((Frame)null);
        }
    }

    /**
     * This method initializes this
     * 
     */
    private void initialize() {
        this.setSize(new java.awt.Dimension((int)(291 * SampleUtil.getDPIScalingMultiplier()), (int)(431 * SampleUtil.getDPIScalingMultiplier())));
        this.setModal(false);
        this.setTitle("Xamance Text Search");
        this.setContentPane(getJpContentPane());
        getjlNumberOccurences().setText("0 "  + "Occurences");
        addComponentListener(this); 
    }
    
    public JLabel getjlProgress()
    {
        if(jlProgress == null)
        {
            jlProgress = new JLabel();
            jlProgress.setText("");
            jlProgress.setBounds(new java.awt.Rectangle((int)(123 * SampleUtil.getDPIScalingMultiplier()),(int)(92 * SampleUtil.getDPIScalingMultiplier()),(int)(136 * SampleUtil.getDPIScalingMultiplier()),(int)(16 * SampleUtil.getDPIScalingMultiplier())));
        }
        return jlProgress;
    }
    
    public JLabel getjlNumberOccurences()
    {
        if(jlNumberOccurences == null)
        {
         jlNumberOccurences = new JLabel();
         jlNumberOccurences.setBounds(new java.awt.Rectangle((int)(16 * SampleUtil.getDPIScalingMultiplier()),(int)(92 * SampleUtil.getDPIScalingMultiplier()),(int)(107 * SampleUtil.getDPIScalingMultiplier()),(int)(16 * SampleUtil.getDPIScalingMultiplier())));
         jlNumberOccurences.setText("JLabel");
        }
        return jlNumberOccurences;
    }

    /**
     * This method initializes jpContentPane    
     *  
     * @return javax.swing.JPanel   
     */
    public JPanel getJpContentPane() {
        if (jpContentPane == null) {
            jpContentPane = new JPanel();
            jpContentPane.setLayout(null);
            jpContentPane.add(getJbClose(), null);
            jpContentPane.add(getjtSearchText(), null);
            jpContentPane.add(getjbSearch(), null);
            jpContentPane.add(getJScrollPane(), null);
            jpContentPane.add(getjlNumberOccurences(), null);
            jpContentPane.add(getJcbCaseSensitive(), null);
            jpContentPane.add(getJcbWholeWord(), null);
            jpContentPane.add(getjbPrevious(), null);
            jpContentPane.add(getjbNext(), null);
            jpContentPane.add(getjlProgress(), null);
        }
        return jpContentPane;
    }
    
    public void componentHidden(ComponentEvent arg0)
    {
        // nothing to do
    }

    public void componentMoved(ComponentEvent arg0)
    {
        // nothing to do
    }

    public void componentResized(ComponentEvent ce)
    {
        doResize();
    }

    public void componentShown(ComponentEvent arg0)
    {
        doResize();
    }
    
    public void doResize()
    {
        Dimension dim = getContentPane().getSize();
        getJScrollPane().setSize(new Dimension(dim.width - getJScrollPane().getX() * 2, dim.height - getJScrollPane().getY() - 40));
        getJScrollPane().revalidate();
        getJScrollPane().repaint();
        getjtSearchText().setSize(new Dimension(dim.width - getjtSearchText().getX() * 2, getjtSearchText().getHeight()));
        getjtSearchText().revalidate();
        getjtSearchText().repaint();
        //getjbSearch().setBounds(dim.width - getjtSearchText().getX() - 20, getjtSearchText().getY(), getjbSearch().getWidth(), getjbSearch().getHeight());
        getJbClose().setBounds((int)((dim.width - getJbClose().getWidth())/2.0), dim.height - 30, getJbClose().getWidth(), getJbClose().getHeight());
    }
    
    /**
     * Returns the next occurence button.
     *  
     * @return Next occurence button.
     */    
    public JButton getjbNext() {
        if (jbNext == null) {
            jbNext = new JButton();
            jbNext.setText("");
            jbNext.setFont(new java.awt.Font("Lucida Sans", java.awt.Font.PLAIN, (int)SampleUtil.getScaledFont(jbNext.getFont().getSize(), 11)));
            jbNext.setIcon(new ImageIcon(getClass().getResource("/images/samples/next.png")));
            jbNext.setToolTipText("Next Occurence");
            jbNext.setBounds(new java.awt.Rectangle((int)(165 * SampleUtil.getDPIScalingMultiplier()),(int)(29 * SampleUtil.getDPIScalingMultiplier()),(int)(24 * SampleUtil.getDPIScalingMultiplier()),(int)(20 * SampleUtil.getDPIScalingMultiplier())));
            jbNext.setFocusPainted(false);
        }
        return jbNext;
    }
    
    /**
     * Returns the previous occurence button.
     *  
     * @return Previous occurence button.
     */    
    public JButton getjbPrevious() {
        if (jbPrevious == null) {
            jbPrevious = new JButton();
            jbPrevious.setText("");
            jbPrevious.setFont(new java.awt.Font("Lucida Sans", java.awt.Font.PLAIN, (int)SampleUtil.getScaledFont(jbPrevious.getFont().getSize(), 11)));
            jbPrevious.setIcon(new ImageIcon(getClass().getResource("/images/samples/previous.png")));
            jbPrevious.setToolTipText("Previous Occurence");
            jbPrevious.setBounds(new java.awt.Rectangle((int)(139 * SampleUtil.getDPIScalingMultiplier()),(int)(29 * SampleUtil.getDPIScalingMultiplier()),(int)(24 * SampleUtil.getDPIScalingMultiplier()),(int)(20 * SampleUtil.getDPIScalingMultiplier())));
            jbPrevious.setFocusPainted(false);
        }
        return jbPrevious;
    }

    /**
     * This method initializes jbClose  
     *  
     * @return javax.swing.JButton  
     */
    public JButton getJbClose() {
        if (jbClose == null) {
            jbClose = new JButton();
            jbClose.setMargin(new Insets(0,0,0,0));
            jbClose.setBounds(new java.awt.Rectangle((int)(94 * SampleUtil.getDPIScalingMultiplier()),(int)(363 * SampleUtil.getDPIScalingMultiplier()),(int)(88 * SampleUtil.getDPIScalingMultiplier()),(int)(25 * SampleUtil.getDPIScalingMultiplier())));
            jbClose.setText("Close");
        }
        return jbClose;
    }

    /**
     * This method initializes jlFields 
     *  
     * @return javax.swing.JList    
     */
    public JList getJlOccurences()
    {
        if (jlOccurences == null)
        {
            jlOccurences = new JList();
            jlOccurences.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
            
        }
        return jlOccurences;
    }

    /**
     * This method initializes jScrollPane  
     *  
     * @return javax.swing.JScrollPane  
     */
    private JScrollPane getJScrollPane()
    {
        if (jScrollPane == null)
        {
            jScrollPane = new JScrollPane();
            jScrollPane.setBounds(new java.awt.Rectangle((int)(16 * SampleUtil.getDPIScalingMultiplier()),(int)(110 * SampleUtil.getDPIScalingMultiplier()),(int)(245 * SampleUtil.getDPIScalingMultiplier()),(int)(244 * SampleUtil.getDPIScalingMultiplier())));
            jScrollPane.setViewportView(getJlOccurences());
        }
        return jScrollPane;
    }

    /**
     * This method initializes jbSearch 
     *  
     * @return javax.swing.JButton  
     */
    public JButton getjbSearch()
    {
        if (jbSearch == null)
        {
            jbSearch = new JButton();
            jbSearch.setText("Search");
            jbSearch.setBounds(new java.awt.Rectangle((int)(16 * SampleUtil.getDPIScalingMultiplier()),(int)(29 * SampleUtil.getDPIScalingMultiplier()),(int)(104 * SampleUtil.getDPIScalingMultiplier()),(int)(20 * SampleUtil.getDPIScalingMultiplier())));
            jbSearch.setMargin(new Insets(0, 0, 0, 0));
        }
        return jbSearch;
    }

    /**
     * This method initializes jtSearchText 
     *  
     * @return javax.swing.JTextField   
     */
    public JTextField getjtSearchText()
    {
        if (jtSearchText == null)
        {
            jtSearchText = new JTextField();
            jtSearchText.setBounds(new java.awt.Rectangle((int)(16 * SampleUtil.getDPIScalingMultiplier()),(int)(6 * SampleUtil.getDPIScalingMultiplier()),(int)(245 * SampleUtil.getDPIScalingMultiplier()),(int)(20 * SampleUtil.getDPIScalingMultiplier())));
            jtSearchText.setMargin(new Insets(1,1,1,1));
        }
        return jtSearchText;
    }

    /**
     * This method initializes jcbCaseSensitive 
     *  
     * @return javax.swing.JCheckBox    
     */
    public JCheckBox getJcbCaseSensitive()
    {
        if (jcbCaseSensitive == null)
        {
            jcbCaseSensitive = new JCheckBox();
            jcbCaseSensitive.setBounds(new java.awt.Rectangle((int)(16 * SampleUtil.getDPIScalingMultiplier()),(int)(53 * SampleUtil.getDPIScalingMultiplier()),(int)(196 * SampleUtil.getDPIScalingMultiplier()),(int)(16 * SampleUtil.getDPIScalingMultiplier())));
            jcbCaseSensitive.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, (int)SampleUtil.getScaledFont(jcbCaseSensitive.getFont().getSize(), 12)));
            jcbCaseSensitive.setText("Case Sensitive");
        }
        return jcbCaseSensitive;
    }

    /**
     * This method initializes jcbWholeWord 
     *  
     * @return javax.swing.JCheckBox    
     */
    public JCheckBox getJcbWholeWord()
    {
        if (jcbWholeWord == null)
        {
            jcbWholeWord = new JCheckBox();
            jcbWholeWord.setBounds(new java.awt.Rectangle((int)(16 * SampleUtil.getDPIScalingMultiplier()),(int)(69 * SampleUtil.getDPIScalingMultiplier()),(int)(172 * SampleUtil.getDPIScalingMultiplier()),(int)(16 * SampleUtil.getDPIScalingMultiplier())));
            jcbWholeWord.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, (int)SampleUtil.getScaledFont(jcbWholeWord.getFont().getSize(), 12)));
            jcbWholeWord.setText("Whole Words Only");
        }
        return jcbWholeWord;
    }
}
